--- Surface:	MiniLab 3
--- Developer:	Farès MEZDOUR
--- Version:	0.4 / Marketing

--- Copyright (c) 2022 Farès MEZDOUR


-- Connexion messages

CONNEXION_DAW = {0xf0, 0x00, 0x20, 0x6b, 0x7f, 0x42, 0x02, 0x02, 0x40, 0x6a, 0x21, 0xf7}
DECONNEXION_DAW = {0xf0, 0x00, 0x20, 0x6b, 0x7f, 0x42, 0x02, 0x02, 0x40, 0x6A, 0x20, 0xf7}
CONNEXION_AL = {0xf0, 0x00, 0x20, 0x6b, 0x7f, 0x42, 0x04, 0x01, 0x60, 0x01, 0x00, 0x02, 0x00, 0xf7}
DECONNEXION_AL = {
				0xf0, 0x00, 0x20, 0x6b, 0x7f, 0x42, 0x04, 0x01, 0x60, 0x0a, 0x0a, 0x5f, 0x51, 0xf7,
				0xf0, 0x00, 0x20, 0x6b, 0x7f, 0x42, 0x02, 0x02, 0x40, 0x6a, 0x10, 0xf7
				}


-- Colors

C_RED_ON =  {0x7f, 0x00, 0x00}
C_RED_OFF =  {0x2a, 0x00, 0x00}
C_GREEN_ON =  {0x00, 0x7f, 0x00}
C_GREEN_OFF =  {0x00, 0x2a, 0x00}
C_ORANGE_ON =  {0x7f, 0x32, 0x00}
C_ORANGE_OFF =  {0x2a, 0x10, 0x00}
C_WHITE_ON =  {0x7f, 0x7f, 0x7f}
C_WHITE_OFF =  {0x2a, 0x2a, 0x2a}
ALL_LED_BLUE_AL = {0xf0, 0x00, 0x20, 0x6b, 0x7f, 0x42, 0x04, 0x01, 0x16, 0x00, 0x00, 0x00, 0x28, 0x00, 0x00, 0x28, 0x00, 0x00, 0x28, 0x00, 0x00, 0x28, 0x00, 0x00, 0x28, 0x00, 0x00, 0x28, 0x00, 0x00, 0x28, 0x00, 0x00, 0x28, 0xf7}

-- Transport Status

LOOP_STATUS = C_ORANGE_OFF
STOP_STATUS = C_WHITE_OFF
PLAY_STATUS = C_GREEN_OFF
REC_STATUS = C_RED_OFF
TAP_STATUS = C_WHITE_OFF


TRANSPORT_STATUS = {
	LOOP_STATUS,
	STOP_STATUS,
	PLAY_STATUS,
	REC_STATUS,
	TAP_STATUS,
}

PAD_MATRIX = {
	0x34, 0x35, 0x36, 0x37,
	0x38, 0x39, 0x3A, 0x3B,
	0x3C, 0x3D, 0x3E, 0x3F,
	0x40, 0x41, 0x42, 0x43,
}

PAD_MATRIX_STATE = {
	0, 0, 0, 0,
	0, 0, 0, 0,
	0, 0, 0, 0,
	0, 0, 0, 0,
}

REC = "00"
PLAY = "00"

G_TIME_POS = "0"

-- IDs

ID_TYPE = ""
ENCODER_ID = {1,2,3,4,5,6,7,8,12}
FADER_ID = {9,10,11}
TRANSPORT_ID = {56,57,58,59,60,61,62}
PADS_ID = {33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48}

ENCODER_HW_ID = {86,87,89,90,110,111,116,117,31}
FADER_HW_ID = {14,15,30}
TRANSPORT_HW_ID = {105,106,107,108,109}

-- Param global variables

G_TIMEOUT = 800
L_VALUE = nil
L_PARAM_NAME = nil
L_CENTERED_VALUE = nil
L_MIN_VALUE = nil
L_MAX_VALUE = nil
L_HW_VALUE = 1
L_HW_CONTROL_ID = 1
PARAM_STATUS = {LAST_VALUE_NUMBER, LAST_CONTROL_ID,L_CENTERED_VALUE, L_MIN_VALUE, L_MAX_VALUE, L_HW_VALUE, L_HW_CONTROL_ID}
line1 = ""
line2 = ""
line1_refresh = ""
line2_refresh = ""



function controller_initialize(applicationName, deviceNewlyDetected)

	-- print("INIT")
	local msg = {}

	local S_connexion = make_lcd_midi_message('MiniLab 3',applicationName, 10)
	table.insert(msg, CONNEXION_DAW)
	table.insert(msg, S_connexion)

	return { midi = msg }

end

function controller_finalize()

	-- print("DEINIT")
	local msg = {}

	local S_deconnexion = make_lcd_midi_message('MiniLab 3','Disconnected', 10)
	table.insert(msg, S_deconnexion)
	table.insert(msg, DECONNEXION_DAW)

	return { midi = msg }

end

function controller_timer_trigger()
	print("TIMETRIGGER")
	local msg = {}

	-- print(line1,line2)

	local S_Idle = make_lcd_midi_message(line1_refresh,line2_refresh, 10)
	table.insert(msg, S_Idle)

	return { midi = msg }
end



-- function controller_version()

-- end





function controller_midi_in(midiEvent, portName)

	L_HW_CONTROL_ID = midiEvent[1]
	L_HW_VALUE = midiEvent[2]
	PARAM_STATUS[7] = L_HW_CONTROL_ID	
	PARAM_STATUS[6] = L_HW_VALUE

	PAD_ID = midiEvent[1] - 35

	
	-- PAD LED (not working)
	-- if midiEvent[0] == 153 or midiEvent[0] == 137 then
	-- 	if midiEvent[0] == 153 then
	-- 		PAD_MATRIX_STATE[PAD_ID] = 1
	-- 		S_PAD_ON = {0xF0,0x00,0x20,0x6B,0x7F,0x42,0x02,0x02,0x16,0x34,0x58,0x58,0x58,0xF7}
	-- 		print(dump(S_PAD_ON))
	-- 		return { midi = S_PAD_ON } 
	-- 	elseif midiEvent[0] == 137 then
	-- 		PAD_MATRIX_STATE[PAD_ID] = 0
	-- 		S_PAD_OFF = {0xF0,0x00,0x20,0x6B,0x7F,0x42,0x02,0x02,0x16,0x34,0x14,0x14,0x14,0xF7}
	-- 		return { midi = S_PAD_OFF } 
	-- 	end

		

	-- end


	if table.contains(ENCODER_HW_ID,L_HW_CONTROL_ID) then
		ID_TYPE = "ENCODER"
	elseif table.contains(FADER_HW_ID,L_HW_CONTROL_ID) then
		ID_TYPE = "FADER"
	elseif table.contains(TRANSPORT_HW_ID,L_HW_CONTROL_ID) then
		ID_TYPE = "TRANSPORT"
	else
		ID_TYPE = "OTHER"
	end




end


-- function CSRefresh() -- Called for Screen Idle State
-- 	-- print("REFRESH")
-- 	local msg = {}
-- 	return { midi = msg }

-- end


function CSFeedback(controlID, current_value, minValue, maxValue, nSubSequentControls, centerValue, assignment)
	--print("CSFEEDBACK")
	local msg = {}
	
	settriggertimer(G_TIMEOUT) 
	if table.contains({13,14,15,16,17}, controlID) then
		--LOOP
		if controlID == 13 then
			local S_LOOP_LED = {}
			if current_value == 1 then
				S_LOOP_LED = {0xF0,0x00,0x20,0x6B,0x7F,0x42,0x02,0x02,0x16,0x57,0x7F,0x32,0x00,0xF7}
				table.insert(msg, S_LOOP_LED)
			else 
				S_LOOP_LED = {0xF0,0x00,0x20,0x6B,0x7F,0x42,0x02,0x02,0x16,0x57,0x14,0x05,0x00,0xF7}
				table.insert(msg, S_LOOP_LED)
			end
		
		-- STOP
		elseif controlID == 14 then
			S_STOP_LED = {}
			if current_value == 1 then
				PLAY = "00"
				REC = "00"
				S_STOP_LED = {0xF0,0x00,0x20,0x6B,0x7F,0x42,0x02,0x02,0x16,0x58,0x7F,0x7F,0x7F,0xF7}
				table.insert(msg, S_STOP_LED)
			else 
				S_STOP_LED = {0xF0,0x00,0x20,0x6B,0x7F,0x42,0x02,0x02,0x16,0x58,0x14,0x14,0x14,0xF7}
				table.insert(msg, S_STOP_LED)
			end

		-- PLAY
		elseif controlID == 15 then
			S_PLAY_LED = {}
			if current_value == 1 then
				PLAY = "02"
				S_PLAY_LED = {0xF0,0x00,0x20,0x6B,0x7F,0x42,0x02,0x02,0x16,0x59,0x00,0x7F,0x00,0xF7}
				table.insert(msg, S_PLAY_LED)
			else 
				PLAY = "00"
				S_PLAY_LED = {0xF0,0x00,0x20,0x6B,0x7F,0x42,0x02,0x02,0x16,0x59,0x00,0x14,0x00,0xF7}
				table.insert(msg, S_PLAY_LED)
			end

		-- REC
		elseif controlID == 16 then
			S_REC_LED = {}
			if current_value == 1 then
				REC = "03"
				S_REC_LED = {0xF0,0x00,0x20,0x6B,0x7F,0x42,0x02,0x02,0x16,0x5A,0x7F,0x00,0x00,0xF7}
				table.insert(msg, S_REC_LED)
			else
				REC = "00" 
				S_REC_LED = {0xF0,0x00,0x20,0x6B,0x7F,0x42,0x02,0x02,0x16,0x5A,0x14,0x00,0x00,0xF7}
				table.insert(msg, S_REC_LED)
			end

		-- TEMPO
		elseif controlID == 17 then
			S_TEMPO_LED = {}
			if current_value == 1 then
				S_TEMPO_LED = {0xF0,0x00,0x20,0x6B,0x7F,0x42,0x02,0x02,0x16,0x5B,0x7F,0x7F,0x7F,0xF7}
				table.insert(msg, S_TEMPO_LED)
			else 
				S_TEMPO_LED = {0xF0,0x00,0x20,0x6B,0x7F,0x42,0x02,0x02,0x16,0x5B,0x14,0x14,0x14,0xF7}
				table.insert(msg, S_TEMPO_LED)
			end
		end


	elseif table.contains(PADS_ID, controlID) then
		print(current_value)
	end

	-- S_SCREEN_TRACK = make_lcd_midi_message(line1_refresh,line2_refresh, 10)
	-- table.insert(msg, S_SCREEN_TRACK)

	return { midi = msg, ret = 16 }

end


-- function CSLabel(controlID, pText, labelLine, textLength, nSubSequentControls)
-- 	return nil
-- end

function CSFeedbackText(controlID, pText, textLength)
	
	--print("CSFEEDBACKTEXT")
	local msg = {}


	if ID_TYPE == "ENCODER" then
		if table.contains({1,2,3,4,5,6,7,8,12}, controlID) then
			line2 = pText
			local S_SCREEN_KNOB = make_lcd_midi_message(line1, line2, 3)
			table.insert(msg, S_SCREEN_KNOB)
		end


	elseif ID_TYPE == "FADER" then
		if table.contains({9,10,11}, controlID) then
			line2 = pText
			local S_SCREEN_FADER = make_lcd_midi_message(line1, line2, 4)
			table.insert(msg, S_SCREEN_FADER)
		end

	elseif ID_TYPE == "TRANSPORT" then
		if table.contains({13}, controlID) then
			line1 = 'Loop Mode'
			line2 = string.upper(pText)
			local S_SCREEN_LOOP = make_lcd_midi_message(line1, line2, 10)
			table.insert(msg, S_SCREEN_LOOP)

		elseif table.contains({14,15,16}, controlID) then
			local S_SCREEN_TRANS = make_lcd_midi_message(line1_refresh, line2_refresh, 10)
			table.insert(msg, S_SCREEN_TRANS)
		end


	elseif ID_TYPE == "OTHER" then
		--print("Other Text")

		if table.contains({13}, controlID) then
			line1 = 'Loop Mode'
			line2 = string.upper(pText)
			local S_SCREEN_LOOP = make_lcd_midi_message(line1, line2, 10)
			table.insert(msg, S_SCREEN_LOOP)


		-- elseif table.contains({20}, controlID) then
		-- 	print("Yes")
		-- 	line1 = 'Fast Forward >>'
		-- 	line2 = string.upper(pText)
		-- 	local S_SCREEN_FF = make_lcd_midi_message(line1, line2, 10)
		-- 	table.insert(msg, S_SCREEN_FF)
		end

	end


	if table.contains({70,71,72,73}, controlID) then
		
		if controlID == 70 then 
			line1 = pText
			line1_refresh = line1
		elseif controlID == 71 then
			line2 = pText
			line2_refresh = line2
			if line2 ~= "Analog Lab V St" then
				-- table.insert(msg, CONNEXION_AL)
				-- table.insert(msg, ALL_LED_BLUE_AL)
				table.insert(msg, DECONNEXION_AL)
			end


		elseif controlID == 73 then
			if pText ~= "RECORD" then
				if line2_refresh == "Analog Lab V St" then
					-- table.insert(msg, CONNEXION_AL)
					-- table.insert(msg, ALL_LED_BLUE_AL)
					table.insert(msg, DECONNEXION_AL)
				end

			print(pText)
			end
		end
		local S_SCREEN_TRACK = make_lcd_midi_message(line1, line2, 10)
		table.insert(msg, S_SCREEN_TRACK)
	
	end



	return { midi = msg } 
end


-- function CSLongFeedbackText(controlID, pText, textLength)
-- 	print("CSLONGFEEDBACKTEXT")
-- 	local msg = {}
-- 	print(pText)

-- 	return { midi = msg } 
-- end

-- function CSLabelSize(controlID, nSubSequentControls)
-- 	print("CSLABEL")
-- 	return 12
-- end


-- function CSLabel(controlID, pText, textLength, textLength)
-- 	print("CSLABEL")
-- 	return nil
-- end


function CSLongLabel(controlID, pText, textLength)
	--print("CSLONGLABEL")
	if textLength > 10 then 
		PARAM_STATUS[2] = string.crunch(pText,10)
	else 
		PARAM_STATUS[2] = pText
	end
	line1 = PARAM_STATUS[2]
	return nil
end

-- function CSActivating(controlID)
-- 	return controlID
-- end


-- function CSBeginOffscreen()
-- 	print("BEGIN")
-- end

-- function CSEndOffscreen()
-- 	print("END")
-- end

function PadOn(ID)
	S_PAD_ON = {0xF0,0x00,0x20,0x6B,0x7F,0x42,0x02,0x02,0x16,PAD_MATRIX[ID],0x7F,0x7F,0x7F,0xF7}
	return S_PAD_ON

end

function PadOff(ID)
	S_PAD_OFF = {0xF0,0x00,0x20,0x6B,0x7F,0x42,0x02,0x02,0x16,PAD_MATRIX[ID],0x28,0x28,0x28,0xF7}
	return S_PAD_OFF
end

-- Control IDs. These are retrieved from the control names. Use these IDs for comparison with controlID





controls = {
	{name = 'encoder1', controlID = 1, objectType = 'Knob', midi={0xB0,0x56,MIDI_LSB}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'encoder2', controlID = 2, objectType = 'Knob', midi={0xB0,0x57,MIDI_LSB}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'encoder3', controlID = 3, objectType = 'Knob', midi={0xB0,0x59,MIDI_LSB}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'encoder4', controlID = 4, objectType = 'Knob', midi={0xB0,0x5A,MIDI_LSB}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'encoder5', controlID = 5, objectType = 'Knob', midi={0xB0,0x6E,MIDI_LSB}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'encoder6', controlID = 6, objectType = 'Knob', midi={0xB0,0x6F,MIDI_LSB}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'encoder7', controlID = 7, objectType = 'Knob', midi={0xB0,0x74,MIDI_LSB}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'encoder8', controlID = 8, objectType = 'Knob', midi={0xB0,0x75,MIDI_LSB}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},

	{name = 'fader1', controlID = 9, objectType = 'VFader', midi={0xB0,0x0E,MIDI_LSB}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'fader2', controlID = 10, objectType = 'VFader', midi={0xB0,0x0F,MIDI_LSB}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'fader3', controlID = 11, objectType = 'VFader', midi={0xB0,0x1E,MIDI_LSB}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'fader4', controlID = 12, objectType = 'Knob', midi={0xB0,0x1F,MIDI_LSB}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},

	{name = 'LOOP', controlID = 13, objectType = 'Button', midi={0xB0,0x69,MIDI_LSB}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'STOP', controlID = 14, objectType = 'Button', midi={0xB0,0x6A,MIDI_LSB}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'PLAY', controlID = 15, objectType = 'Button', midi={0xB0,0x6B,MIDI_LSB}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'RECORD', controlID = 16, objectType = 'Button', midi={0xB0,0x6C,MIDI_LSB}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'TAP', controlID = 17, objectType = 'Button', midi={0xB0,0x6D,MIDI_LSB}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'REWIND', controlID = 18, objectType = 'Button', midi={0xB0,0x1D,0x3E}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'REWIND2', controlID = 19, objectType = 'Button', midi={0xB0,0x1D,0x3D}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'FASTFORWARD', controlID = 20, objectType = 'Button', midi={0xB0,0x1D,0x41}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'FASTFORWARD2', controlID = 21, objectType = 'Button', midi={0xB0,0x1D,0x42}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},

	{name = 'trackp', controlID = 22, objectType = 'Button', midi={0xB0,0x1C,0x41}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'trackp2', controlID = 23, objectType = 'Button', midi={0xB0,0x1C,0x42}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'trackm', controlID = 24, objectType = 'Button', midi={0xB0,0x1C,0x3E}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'trackm2', controlID = 25, objectType = 'Button', midi={0xB0,0x1C,0x3D}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'Main Encoder Click', controlID = 26, objectType = 'Button', midi={0xB0,0x76,MIDI_LSB}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'Shift Encoder Click PRESS', controlID = 27, objectType = 'Button', midi={0xB0,0x77,0x7F}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'Shift Encoder Click RELEASE', controlID = 28, objectType = 'Button', midi={0xB0,0x77,0x00}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},    

	{name = 'Pitch Bend', controlID = 29, objectType = 'Wheel', midi={0xE0,MIDI_MSB,MIDI_LSB}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'Modulation', controlID = 30, objectType = 'Wheel', midi={0xB0,0x01,MIDI_LSB}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'Keyboard', controlID = 31, objectType = 'Keyboard', midiType = 'Keyboard', startKey = 36, numberKeys = 49, midi={0x90,MIDI_Wildcard,MIDI_Wildcard}, fbType = FB_TEXTONLY, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'Sustain Pedal', controlID = 32, objectType = 'Sustain Pedal', midiType = 'Momentary', midi={0xB0,0x40,MIDI_LSB}, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},

	{name = 'Pad 1', controlID = 33, objectType = 'Drumpad', midi={0x99,0x24,MIDI_LSB}, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'}, 
	{name = 'Pad 2', controlID = 34, objectType = 'Drumpad', midi={0x99,0x25,MIDI_LSB}, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'}, 
	{name = 'Pad 3', controlID = 35, objectType = 'Drumpad', midi={0x99,0x26,MIDI_LSB}, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'}, 
	{name = 'Pad 4', controlID = 36, objectType = 'Drumpad', midi={0x99,0x27,MIDI_LSB}, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'}, 
	{name= ' Pad 5', controlID = 37, objectType = 'Drumpad', midi={0x99,0x28,MIDI_LSB}, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'Pad 6', controlID = 38, objectType = 'Drumpad', midi={0x99,0x29,MIDI_LSB}, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'Pad 7', controlID = 39, objectType = 'Drumpad', midi={0x99,0x2A,MIDI_LSB}, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'Pad 8', controlID = 40, objectType = 'Drumpad', midi={0x99,0x2B,MIDI_LSB}, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'Pad 9', controlID = 41, objectType = 'Drumpad', midi={0x99,0x2C,MIDI_LSB}, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'}, 
	{name = 'Pad 10', controlID = 42, objectType = 'Drumpad', midi={0x99,0x2D,MIDI_LSB}, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'}, 
	{name = 'Pad 11', controlID = 43, objectType = 'Drumpad', midi={0x99,0x2E,MIDI_LSB}, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'}, 
	{name = 'Pad 12', controlID = 44, objectType = 'Drumpad', midi={0x99,0x2F,MIDI_LSB}, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'}, 
	{name = 'Pad 13', controlID = 45, objectType = 'Drumpad', midi={0x99,0x30,MIDI_LSB}, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'}, 
	{name = 'Pad 14', controlID = 46, objectType = 'Drumpad', midi={0x99,0x31,MIDI_LSB}, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'}, 
	{name = 'Pad 15', controlID = 47, objectType = 'Drumpad', midi={0x99,0x32,MIDI_LSB}, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},
	{name = 'Pad 16', controlID = 48, objectType = 'Drumpad', midi={0x99,0x33,MIDI_LSB}, inport = 'Minilab3 MIDI', outport = 'Minilab3 MIDI'},

	{name = 'LOOP LED', controlID = 63, midi={0xF0,0x00,0x20,0x6B,0x7F,0x42,0x02,0x02,0x16,0x57,MIDI_Wildcard,MIDI_Wildcard,MIDI_Wildcard,0xF7}, inport='Minilab3 MIDI', outport='Minilab3 MIDI'},
	{name = 'STOP LED', controlID = 64, midi={0xF0,0x00,0x20,0x6B,0x7F,0x42,0x02,0x02,0x16,0x58,MIDI_Wildcard,MIDI_Wildcard,MIDI_Wildcard,0xF7}, inport='Minilab3 MIDI', outport='Minilab3 MIDI'},
	{name = 'PLAY LED', controlID = 65, midi={0xF0,0x00,0x20,0x6B,0x7F,0x42,0x02,0x02,0x16,0x59,MIDI_Wildcard,MIDI_Wildcard,MIDI_Wildcard,0xF7}, inport='Minilab3 MIDI', outport='Minilab3 MIDI'},
	{name = 'REC LED', controlID = 66, midi={0xF0,0x00,0x20,0x6B,0x7F,0x42,0x02,0x02,0x16,0x5A,MIDI_Wildcard,MIDI_Wildcard,MIDI_Wildcard,0xF7}, inport='Minilab3 MIDI', outport='Minilab3 MIDI'},
	{name = 'TEMPO LED', controlID = 67, midi={0xF0,0x00,0x20,0x6B,0x7F,0x42,0x02,0x02,0x16,0x5B,MIDI_Wildcard,MIDI_Wildcard,MIDI_Wildcard,0xF7}, inport='Minilab3 MIDI', outport='Minilab3 MIDI'},

	{name='Track Info', controlID = 70, fbType=FB_TEXTONLY, inport='Minilab3 MIDI', outport='Minilab3 MIDI'},
	{name='Inst', controlID=71,fbType=FB_TEXTONLY, inport='Minilab3 MIDI', outport='Minilab3 MIDI'},
	{name='Tempo', controlID=72,fbType=FB_TEXTONLY, inport='Minilab3 MIDI', outport='Minilab3 MIDI'},
	{name='Arm', controlID=73,fbType=FB_TEXTONLY, inport='Minilab3 MIDI', outport='Minilab3 MIDI'},


}

function controller_info()
	return {
		model = 'Minilab 3',
		manufacturer = 'Arturia',
		version = 0.1,

		device_request = {0xF0, 0x7E, MIDI_Wildcard, 0x06, 0x01, 0xF7},
		device_reply = {0xF0, 0x7E, 0x7F, MIDI_Wildcard, 0x02, 0x00, 0x20, 0x6B, 0x02, 0x00, 0x04, 0x04, MIDI_Wildcard, MIDI_Wildcard, MIDI_Wildcard, MIDI_Wildcard, 0xF7},
		copyright = 'Arturia Corp.',

		items =  controls,

		assignments = {

		--------------------------------------------------------------

			{zone='Control Surface: MiniLab 3'},

			{control='encoder1', trackParam=CS_INSTRUMENTPAR1},
			{control='encoder2', trackParam=CS_INSTRUMENTPAR1, paramOffset=1},
			{control='encoder3', trackParam=CS_INSTRUMENTPAR1, paramOffset=2},
			{control='encoder4', trackParam=CS_INSTRUMENTPAR1, paramOffset=3},
			{control='encoder5', trackParam=CS_INSTRUMENTPAR1, paramOffset=4},
			{control='encoder6', trackParam=CS_INSTRUMENTPAR1, paramOffset=5},
			{control='encoder7', trackParam=CS_INSTRUMENTPAR1, paramOffset=6},
			{control='encoder8', trackParam=CS_INSTRUMENTPAR1, paramOffset=7},

			{control='fader1', trackParam=AUVOLUME, paramName='@tp'},
			{control='fader2', trackParam=AUSEND1, paramOffset=0, paramName='@tp'},
			{control='fader3', trackParam=AUSEND1, paramOffset=1, paramName='@tp'},
			{control='fader4', trackParam=AUPAN, paramName='@tp'},


			{control='LOOP', keyCmd=15}, -- Cycle Mode
			{control='RECORD', keyCmd=7}, -- Record
			--{control='PAUSE', keyCmd=4}, -- Pause
			{control='PLAY', keyCmd=3}, -- Play
			{control='STOP', keyCmd=5}, -- Stop
			{control='TAP', keyCmd=532}, -- Tap
			{control='REWIND', keyCmd=10}, -- REWIND
			{control='FASTFORWARD', keyCmd=11}, -- FASTFORWARD
			{control='REWIND2', keyCmd=10}, -- REWIND
			{control='FASTFORWARD2', keyCmd=11}, -- FASTFORWARD

			{control='trackm', keyCmd=1272},
			{control='trackm2', keyCmd=1272},
			{control='trackp', keyCmd=1273},
			{control='trackp2', keyCmd=1273},
			{control='Main Encoder Click', keyCmd=2397},
			{control='Shift Encoder Click PRESS', keyCmd=749},
			{control='Shift Encoder Click RELEASE', keyCmd=2315},

			{control='Track Info', trackParam=CS_NAME, paramName='@tp', shortParamName="@tn"},
			{control='Inst', trackParam=CS_INSTRUMENT},
			{control='Arm', trackParam=CS_RECRDY},



			


		},
	}
end



-- UTILITY FUNCTIONS


function dump(o)
	-- Put this function ito "print" function to see the table content
	if type(o) == 'table' then
		local s = '{ '
		for k,v in pairs(o) do
			if type(k) ~= 'number' then k = ' " '..k..' " ' end
			s = s .. '[' ..k..'] = ' .. dump(v) .. ','
		end

		return s .. '} '
	else

		return tostring(o)
	end
end 


function make_lcd_midi_message(line1, line2, page_type)
	-- Returns a table containing the SysEx message to display on the MiniLab3 screen
	data_control = ""

	if page_type == 1 then
		data_control = ""
	end
	if page_type == 2 then
		data_control = "1F 02 01"
	end
	if page_type == 3 then
		print(PARAM_STATUS[6])
		if string.len(string.format("%x",PARAM_STATUS[6])) == 1 then
			data_control = "1F 03 01 0"..string.format("%x",PARAM_STATUS[6])
		else
			data_control = "1F 03 01 "..string.format("%x",PARAM_STATUS[6])
		end
	end
	if page_type == 4 then
		if string.len(string.format("%x",PARAM_STATUS[6])) == 1 then
			data_control = "1F 04 01 0"..string.format("%x",PARAM_STATUS[6])
		else
			data_control = "1F 04 01 "..string.format("%x",PARAM_STATUS[6])
		end
	end
	if page_type == 5 then
		data_control = "1F 05 01 00"
	end

	if page_type == 10 then
		data_control = "1F 07 01 " .. REC .. " " .. PLAY .. " 01"
	end

	local sysex = "f0 00 20 6b 7f 42 04 02 60 " .. data_control .. " 00 00 01 " .. stringToHex(string.sub(line1,1,31)) .. " 00 02 " .. stringToHex(string.sub(line2,1,31)) .. " 00 f7 "
	-- sysex = "f0 00 20 6b 7f 42 04 02 60 1f 02 01 00 01 30 31 32 00 02 30 31 32 00 f7 "
	local table = StringToTable(sysex)

	return table

end


function stringToHex(text)
	-- Convert a string to an table of hexadecimal number ( usefull for SysEx messages )

	local hexStringToReturn = ""
	for i=1, string.len(text) do
		if string.len(hexStringToReturn) > 0 then
			hexStringToReturn = hexStringToReturn .. " "
		end
		hexStringToReturn = hexStringToReturn .. string.format("%X", string.byte(text,i))
	end
	return hexStringToReturn
end

function StringToTable(string)
	local table = {}
	local step = ""
	local index = 1
	for c in string:gmatch"." do
		if c == " " then
			table[index] = '0x'..step
			step = ""
			index = index + 1
		else
			step = step..c
		end
	end
	for i=1, #table do
		table[i] = tonumber(table[i])
	end

	return table

end
		

function len(T)
	-- Return the table length

	local count = 0
	for i in pairs(T) do
		count = count + 1
	end

	return count

end

function table.contains(table, element)
	present = false
	for _, value in pairs(table) do
		if value == element then
			present = true
		end
	end
	return present
end